/*
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * (the "License"); you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://www.mozilla.org/MPL/>.
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, WITHOUT
 * WARRANTY OF ANY KIND, either express or implied. See the License for the specific
 * language governing rights and limitations under the License.
 * 
 * The Original Code is the Venice Web Communities System.
 * 
 * The Initial Developer of the Original Code is Eric J. Bowersox <erbo@silcom.com>,
 * for Silverwrist Design Studios.  Portions created by Eric J. Bowersox are
 * Copyright (C) 2003 Eric J. Bowersox/Silverwrist Design Studios.  All Rights Reserved.
 * 
 * Contributor(s): 
 */
package com.silverwrist.dynamo.testmod;

import java.util.*;
import com.silverwrist.dynamo.except.*;
import com.silverwrist.dynamo.iface.*;

class TestMod1DClass implements DynamicClass
{
  /*--------------------------------------------------------------------------------
   * Static data members
   *--------------------------------------------------------------------------------
   */

  private static TestMod1DClass _self = null;

  /*--------------------------------------------------------------------------------
   * Constructor
   *--------------------------------------------------------------------------------
   */

  private TestMod1DClass()
  { // do nothing
  } // end constructor

  /*--------------------------------------------------------------------------------
   * Implementations from interface NamedObject
   *--------------------------------------------------------------------------------
   */

  public String getName()
  {
    return "TestMod1";

  } // end getName

  /*--------------------------------------------------------------------------------
   * Implementations from interface DynamicClass
   *--------------------------------------------------------------------------------
   */

  public Object get(String property_name) throws DynamicObjectException
  {
    throw new CodeNotFoundException(this,CodeNotFoundException.GET,property_name);

  } // end get

  public void set(String property_name, Object value) throws DynamicObjectException
  {
    throw new CodeNotFoundException(this,CodeNotFoundException.SET,property_name);

  } // end set

  public Object call(String method_name, Object[] parameters) throws DynamicObjectException
  {
    throw new CodeNotFoundException(this,CodeNotFoundException.CALL,method_name);

  } // end call

  public Object call(String method_name, List parameters) throws DynamicObjectException
  {
    throw new CodeNotFoundException(this,CodeNotFoundException.CALL,method_name);

  } // end call

  public DynamicObject cast(Object source) throws ClassCastException
  {
    if (source instanceof TestMod1DObject)
      return (DynamicObject)source;
    throw new ClassCastException("DClass:TestMod1.cast: invalid");

  } // end cast
  
  /*--------------------------------------------------------------------------------
   * External static operations
   *--------------------------------------------------------------------------------
   */

  public static DynamicClass get()
  {
    if (_self==null)
      _self = new TestMod1DClass();
    return _self;

  } // end get

} // end class TestMod1DClass
